from torchlap.experiments._entry_loader import get_entry, PhaseType
from torchlap.experiments._model_loading import load_model
from torchlap.interpreting.interpretation_evaluation_runner import InterpretingEvalRunner
from torchlap.utils.hooker import Hooker


def main() -> None:

    ep = get_entry(PhaseType.EVALINTERPRET)
    conf = ep.conf
    model = ep.model
    model = load_model(model, conf)
    model.eval()

    runner = InterpretingEvalRunner(conf, model)
    with Hooker(*conf.hooks_by_phase[conf.phase_type]):
        runner.evaluate()


if __name__ == '__main__':
    main()
