from torchlap.experiments._entry_loader import get_entry, PhaseType
from torchlap.experiments._model_loading import load_model
from torchlap.interpreting.interpreting_runner import InterpretingRunner
from torchlap.utils.hooker import Hooker


def main() -> None:

    ep = get_entry(PhaseType.INTERPRET)
    conf = ep.conf
    model = ep.model
    model = load_model(model, conf)
    model.eval()

    runner = InterpretingRunner(conf, model)
    with Hooker(*conf.hooks_by_phase[conf.phase_type]):
        runner.interpret()


if __name__ == '__main__':
    main()
