from .base_config import BaseConfig, PhaseType
from ..data.content_loaders.imagenet_loader import ImagenetLoader
from ..model_evaluation.multiclass_evaluator import MulticlassEvaluator

class ImagenetConfigs(BaseConfig):
    
    def __init__(self, try_name: str, try_num: int, input_size, phase_type: PhaseType) -> None:
        super().__init__(try_name, try_num, 'data/imagenet/extracted', input_size, phase_type, ImagenetLoader, MulticlassEvaluator.standard_creator('categorical_probability', include_top5=True))

        # replaced configs!
        self.batch_size = 64
        self.big_batch_size = 4
        self.max_epochs = 10

        self.title_of_reference_metric_to_choose_best_epoch = 'Accuracy'
        self.operator_to_decide_on_improvement_of_val_reference_metric = '>='
        self.keep_best_and_last_epochs_only = True
