from typing import Tuple
from ...configs.celeba_configs import CelebAConfigs, CelebATag
from ...models.model import Model
from ..entrypoint import BaseEntrypoint
from ...models.celeba.single_tag_org_inception import CelebAORGInception


class EntryPoint(BaseEntrypoint):
    
    def _get_conf_model(self) -> Tuple[CelebAConfigs, Model]:
        conf = CelebAConfigs('CelebA_Inception_Org', 8, 299, self.phase_type)
        
        conf.max_epochs = 12
        conf.main_tag = CelebATag.SmilingTag
        conf.tags = [conf.main_tag.name]

        model = CelebAORGInception(conf.main_tag.name, 0.4)

        return conf, model

