from typing import Tuple
from ...configs.celeba_configs import CelebAConfigs, CelebATag
from ...models.model import Model
from ..entrypoint import BaseEntrypoint
from ...models.celeba.org_resnet import CelebAORGResNet18


class EntryPoint(BaseEntrypoint):

    def _get_conf_model(self) -> Tuple[CelebAConfigs, Model]:
        conf = CelebAConfigs('CelebA_ResNet_Org', 9, 224, self.phase_type)
        
        conf.max_epochs = 12
        conf.main_tag = CelebATag.SmilingTag
        conf.tags = [conf.main_tag.name]

        model = CelebAORGResNet18(conf.main_tag.name)

        return conf, model

