from typing import Tuple
from ...configs.rsna_configs import RSNAConfigs
from ...models.model import Model
from ..entrypoint import BaseEntrypoint
from ...models.rsna.org_resnet import RSNAORGResNet18


class EntryPoint(BaseEntrypoint):
    
    def _get_conf_model(self) -> Tuple[RSNAConfigs, Model]:
        config = RSNAConfigs('RSNA_ResNet_Org', 1, 224, self.phase_type)
        model = RSNAORGResNet18()

        return config, model
