from torchlap.experiments._entry_loader import get_entry, PhaseType
from torchlap.training.trainer import Trainer
from torchlap.data.data_loader import DataLoader, RunType
from torchlap.utils.hooker import Hooker


def main() -> None:

    ep = get_entry(PhaseType.TRAIN)
    conf = ep.conf
    model = ep.model

    train_data_loader = DataLoader(conf, 'train', RunType.TRAIN)
    val_data_loader = DataLoader(conf, 'val', RunType.VAL)

    trainer = Trainer(model, conf, 
        train_data_loader, val_data_loader)

    with Hooker(*conf.hooks_by_phase[conf.phase_type]):
        trainer.train()


if __name__ == '__main__':
    main()
